/*!

\defgroup app app
\brief Applications

\defgroup appCNN appCNN
\ingroup app
\brief CNN applications

\defgroup benchmark benchmark
\brief Bechmarks

\defgroup benchmarkCNN benchmarkCNN
\brief CNN benchmarks
\ingroup benchmark

\defgroup test test
\brief Test

\mainpage Introduction

\section sectionOverview Overview

The Texas Instruments Machine Learning (TIML) library is C implementation of common machine learning functions optimized for TI embedded devices.  Initially, the library supports convolutional neural networks (CNNs), but will grow with time in scope.  The library has a minimal set of dependencies upon other libraries to simplify the installation and use.

\section sectionInstallation Installation

\subsection subsectionDependencies Dependencies
<B> TIML library dependencies </B><BR>
The TIML library requires a high performance C basic linear algebra subprogram (CBLAS) library and a library for reading Joint Photographic Experts Group (JPEG) images.  An optimized CBLAS implementation is included with TI embedded devices.  For pre development work on a desktop, a reference (unoptimized) CBLAS implementation can be downloaded from http://www.netlib.org/blas/blast-forum/cblas.tgz or in Ubuntu using the command

<KBD>
sudo apt-get install libatlas-base-dev
</KBD>

A JPEG library, libjpeg, can be downloaded from \n
http://sourceforge.net/projects/libjpeg/files/latest/download?source=files \n
or in Ubuntu using the command

<KBD>
sudo apt-get install libjpeg-dev
</KBD>

<B> Application dependencies </B><BR>
The ImageNet database conversion application resizes all the images to size 256*256. The resizing is done using openCV. In Ubuntu, use the following command to install openCV

<KBD>
sudo apt-get install libopencv-dev
</KBD>

The interop application converts a CNN model in Caffe format to TIML CNN format. The Caffe format depends on google's protocol buffer library. To install the library, use command

<KBD>
sudo apt-get install libprotobuf-dev
</KBD>


\subsection subsectionDirectoryStructure Directory Structure

Install the TIML library by unzipping the zip file to a directory referred to as <install_directory>.
At a terminal prompt, change the working directory to <KBD><install_directory>/build</KBD> and use the command <KBD>make all</KBD> to compile the library.
The library file will be placed inside the <KBD><install_directory>/bin</KBD> folder.

The directory structure of the compiled library is shown as follows:
- <KBD><install_directory>/bin</KBD>: library binary file directory
- <KBD><install_directory>/build</KBD>: makefile directory
- <KBD><install_directory>/doc</KBD>: doxygen file directory
- <KBD><install_directory>/src/common</KBD>: common library directory
	- <KBD><install_directory>/src/common/api</KBD>: library API source file
	- <KBD><install_directory>/src/common/cnn</KBD>: cnn moudule source file
	- <KBD><install_directory>/src/common/util</KBD>: util moudule source file
- <KBD><install_directory>/src/test</KBD>: test module directory
	- <KBD><install_directory>/src/test/cnn</KBD>: cnn test source file
	- <KBD><install_directory>/src/test/util</KBD>: util test source file
- <KBD><install_directory>/src/benchmark</KBD>: benchmark module directory
	- <KBD><install_directory>/src/benchmark/cnn</KBD>: cnn benchmark source file
	   - <KBD><install_directory>/src/benchmark/cnn/class</KBD>: cnn classification benchmark source file
- <KBD><install_directory>/src/app</KBD>: application module directory
	- <KBD><install_directory>/src/app/cnn</KBD>: cnn application source file
      - <KBD><install_directory>/src/app/cnn/class</KBD>: cnn classification application source file
         - <KBD><install_directory>/src/app/cnn/class/cifar10</KBD>: cnn CIFAR10 database classification application source file
         - <KBD><install_directory>/src/app/cnn/class/imagenet</KBD>: cnn ImageNet database classification application source file
         - <KBD><install_directory>/src/app/cnn/class/mnist</KBD>: cnn MNIST database classification application source file
      - <KBD><install_directory>/src/app/cnn/scene</KBD>: cnn scene labeling application source file
         - <KBD><install_directory>/src/app/cnn/scene/sbd</KBD>: cnn stanford background dataset scene labeling application source file
      - <KBD><install_directory>/src/app/cnn/interop</KBD>: cnn interoperation application source file
         - <KBD><install_directory>/src/app/cnn/interop/caffe</KBD>: cnn-caffe interoperation application source file
      - <KBD><install_directory>/src/app/cnn/convert</KBD>: cnn database conversion application source file
         - <KBD><install_directory>/src/app/cnn/convert/imagenet</KBD>: cnn ImageNet database conversion application source file
         - <KBD><install_directory>/src/app/cnn/convert/sbd</KBD>: cnn SBD database conversion application source file
- <KBD><install_directory>/src/database</KBD>: database directory
	- cifar10: Canadian Institute for Advanced Research-10 Class
	- imagenet: ImageNet 2012
	- mnist: Mixed National Institute of Standards and Technology
	- sbd: Stanford Background Dataset
	- model: pretrained models
		- cifar10
		- alexnet
		- caffenet
		- vggnet
		- mnist
		- sbd

\subsection subsectionDoc Document Genearation
Documents of html and pdf formats can be generated using Doxygen. Make sure you have both latex and Doxygen installed. In Ubuntu, the installation commands are

- <KBD>sudo apt-get install doxygen</KBD>
- <KBD>sudo apt-get install texlive-full</KBD>

Use the command <KBD>doxygen <install- <KBD><install_directory>/src/app/cnn/scene</KBD>: cnn scene labeling application source file_directory>/doc/timl.Doxyfile</KBD> to generate the documents.
The html version is located at <KBD>doxygen <install_directory>/doc/html</KBD>. To generate the pdf version, change the directory
to <KBD>doxygen <install_directory>/doc/latex</KBD> and run the command <KBD>make</KBD>. A filed named refman.pdf will be generated in the currnet folder.

\subsection subsectionImageDatabases Image Databases

In order to run the examples provided by the library, it is required to download additional databases of test images.

<B>MNIST</B>

The MNIST database of handwritten digits, available from this page, has a training set of 60,000 examples, and a test set of 10,000 examples. It is a subset of a larger set available from NIST. The digits have been size-normalized and centered in a fixed-size image. 

You can download the MNIST database from http://yann.lecun.com/exdb/mnist/ or simpliy change the directory to <KBD><install_directory>/src/database/mnist</KBD> and run the script <KBD>./databaseMNISTDownload.sh</KBD>.
After the download, there should be 4 files in the folder:
- <KBD>t10k-images.idx3-ubyte</KBD>
- <KBD>t10k-labels.idx1-ubyte</KBD>
- <KBD>train-images.idx3-ubyte</KBD>
- <KBD>train-labels.idx1-ubyte</KBD>.

<B>CIFAR10</B>

The CIFAR-10 dataset consists of 60000 32x32 colour images in 10 classes, with 6000 images per class.
The dataset is divided into five training batches and one test batch, each with 10000 images. The test batch contains exactly 1000 randomly-selected images from each class.
The training batches contain the remaining images in random order, but some training batches may contain more images from one class than another.
Between them, the training batches contain exactly 5000 images from each class. 

You can download the CIFAR10 database from http://www.cs.toronto.edu/~kriz/cifar.html or simpliy change the directory to <KBD><install_directory>/src/database/cifar10</KBD> and run the script <KBD>./databaseCIFAR10Download.sh</KBD>.
After the download, there should be 6 files in the folder:
- <KBD>data_batch_1.bin</KBD>
- <KBD>data_batch_2.bin</KBD>
- <KBD>data_batch_3.bin</KBD>
- <KBD>data_batch_4.bin</KBD>
- <KBD>data_batch_5.bin</KBD>
- <KBD>test_batch_6.bin</KBD>

<B>ImageNet</B>

ImageNet is an image dataset organized according to the WordNet hierarchy.Each meaningful concept in WordNet, possibly described by multiple words or word phrases, is called a "synonym set" or "synset".
There are more than 100,000 synsets in WordNet, majority of them are nouns (80,000+).
ImageNet aims to provide on average 1000 images to illustrate each synset. Images of each concept are quality-controlled and human-annotated.

Download the database from http://www.image-net.org/challenges/LSVRC/2012/nonpub-downloads to <install_directory>/database/imagnet.
You need to register before you can download the database.http://dags.stanford.edu/projects/scenedataset.html
- Download the training images of size 138GB and MD5: 1d675b47d978889d74fa0da5fadfb00e
- Download the validation images of size 6.3GB and MD5: 29b22e2961454d5413ddabcf34fc5622
- Download the auxiliary  files by changing the working directory to <KBD><install_directory>/src/database/imagnet</KBD> and runing the script <KBD> ./databaseImageNetDownload.sh </KBD>
- Extract all the files to the <install_directory>/src/database/imagnet
- Change run the script ./databaseImageNetConvert.sh to convert the raw database to a format that is ready to be processed by TIML. You may need to change the path variables in this script if you choose to store the database 
  in other directories. You can also specify the number of images to be converted in the script.

After the conversion, there should be two folders, test and train, in <install_directory>/src/database/imagnet.
There will be a single labels.txt file in each of the folder. All the images will be resized to 256*256.

<B>Stanford Background Dataset</B>

The Stanford Background Dataset is a new dataset introduced in Gould et al. (ICCV 2009) for evaluating methods for geometric and semantic scene understanding.
The dataset contains 715 images chosen from existing public datasets: LabelMe, MSRC, PASCAL VOC and Geometric Context.
The selection criteria were for the images to be of outdoor scenes, have approximately 320-by-240 pixels, contain at least one foreground object, and have the horizon position within the image.

You can download the database from http://dags.stanford.edu/data/iccv09Data.tar.gz 
or simply change the working directory to <KBD><install_directory>/src/database/sbd</KBD> and run the script <KBD>databaseSBDDownload.sh</KBD>
To convert the database to TIML compatible format, run the script ./databaseSBDConvert.sh. You can specify the number of images used for training and testing by changing the corresponding variables in the script. After running the script, there should be two folders named "train"  and "test" in the current folder.

\subsection subsectionCNNPretrainedModels CNN Pretrained Models
TIML can convert models pretrained by Caffe\cite Caffe to a format that is compatible with TIML.
Caffe is a deep learning framework developed by the Berkeley Vision and Learning Center (BVLC).
You can train your CNN on Caffe on CPU or GPU, save the parameters and then convert it to a format supported by TIML.

<B> AlexNet </B>\cite AlexNet

AlexNet is a deep convolutional neural network to classify the 1.3 million high-resolution images in the LSVRC-2010 ImageNet training set into the 1000 different classes.
On the test data, AlexNet achieved top-1 and top-5 error rates of 39.7\% and 18.9\% which is considerably better than the previous state-of-the-art results.
The neural network, which has 60 million parameters and 500,000 neurons, consists of five convolutional layers, some of which are followed by max-pooling layers, and two globally connected layers with a final 1000-way softmax. 
- Download the Caffe AlexNet binary file from http://dl.caffe.berkeleyvision.org/bvlc_alexnet.caffemodel to <install_directory>/src/database/model/alexnet
- Download the Caffe AlexNet depoly file from https://github.com/BVLC/caffe/blob/master/models/bvlc_alexnet/deploy.prototxt to <install_directory>/src/database/model/alexnet
- Run the script ./databaseModelAlexNetInterop.sh to perform the conversion

After the conversion, there should two files in <install_directory>/database/model/alexnet:
- databaseModelAlexNet.m			<I>A text file that defines the structure of the CNN</I>
- databaseModelAlexNet.m.params	<I>A binary file that stores the parameters of the CNN</I>

<B> CaffeNet </B>

The CaffeNet is a replication of the model described in the AlexNet publication with some differences:
- not training with the relighting data-augmentation;
- the order of pooling and normalization layers is switched (in CaffeNet, pooling is done before normalization).

This model obtains a top-1 accuracy 57.4% and a top-5 accuracy 80.4% on the validation set, using just the center crop.

- Download the Caffe CaffeNet binary file from http://dl.caffe.berkeleyvision.org/bvlc_reference_caffenet.caffemodel to <install_directory>/database/model/caffenet
- Download the Caffe CaffeNet depoly file from https://github.com/BVLC/caffe/blob/master/models/bvlc_reference_caffenet/deploy.prototxt to <install_directory>/src/database/model/caffenet
- Run the script ./databaseModelCaffeNetInterop.sh to perform the conversion

After the conversion, there should two files in <install_directory>/src/database/model/caffenet:
- databaseModelCaffeNet.m
- databaseModelCaffeNet.m.params

<B> VGGNet </B> \cite VGG

VGGNet shows that a significant improvement on the prior-art configurations can be achieved by increasing the depth to 16-19 weight layers, which is substantially deeper than what has been used in the prior art.
To reduce the number of parameters in such very deep networks, the researchers use very small 3×3 filters in all convolutional layers.
 
- Download the VGGNet binary file from http://www.robots.ox.ac.uk/~vgg/software/very_deep/caffe/VGG_ILSVRC_16_layers.caffemodel to <install_directory>/src/database/model/vggnet
- Download the VGGNet depoly file from https://gist.githubusercontent.com/ksimonyan/211839e770f7b538e2d8/raw/0067c9b32f60362c74f4c445a080beed06b07eb3/VGG_ILSVRC_16_layers_deploy.prototxt to <install_directory>/src/database/model/vggnet
- Run the script ./databaseModelVGGNetInterop.sh to perform the conversion

After the conversion, there should two files in <install_directory>/src/database/model/caffenet:
- databaseModelVGGNet.m
- databaseModelVGGNet.m.params

<B> MNIST </B>
A pretrained CNN for MNIST database is located at <install_directory>/src/database/model/mnist:
- databaseModelMNIST.m
- databaseModelMNIST.m.params

<B> CIFAR10 </B>
A pretrained CNN for CIFAR10 database is located at <install_directory>/src/database/model/cifar10:
- databaseModelCIFAR10.m
- databaseModelCIFAR10.m.params


\section sectionCNNs Convolutional Neural Networks (CNNs)

The TIML library provides a set of APIs that allow a user to implement a CNN architecture and perform training and testing.  Common CNN layer types are supported in the current version and more will be added in future versions.  Both image classification and scene labeling examples are provided.

This section briefly describes the use of CNN library APIs.  For complete examples, refer to the folder <KBD><install_directory>/src/app/cnn</KBD>

\subsection subsectionTrainingParameters Training Parameters

The default training parameters structure is obtained by calling `timlCNNTrainingParamsDefault()`.  Default parameters can be overridden by setting specific field values (refer to `timlCNNTrainingParams` for details).

\subsection subsectionLayers Layers

This section describes the different CNN layers supported by the TIML library.  To create a CNN, call `timlCNNCreateConvNeuralNetwork()`.  Here is an example code block in `timlTestCNNSimpleTraining()` that generates a simple CNN with 8 layer types:

~~~~~~~~~~~~~~~{.c}
   trainingParams              = timlCNNTrainingParamsDefault();
   trainingParams.batchSize    = BATCH_SIZE;
   trainingParams.learningRate = 0.1;
   cnn = timlCNNCreateConvNeuralNetwork(trainingParams, 0);
   inputParams       = timlCNNInputParamsDefault();
   inputParams.scale = 1.0/256.0;
   timlCNNAddInputLayer(cnn, IMAGE_ROW, IMAGE_COL, IMAGE_CHANNEL, inputParams);            // input layer
   timlCNNAddConvLayer(cnn, 5, 5, 1, 1, 6, timlCNNConvParamsDefault());                    // conv layer
   timlCNNAddNonlinearLayer(cnn, Util_Relu);                                               // relu layer
   timlCNNAddPoolingLayer(cnn, 4, 4, 4, 4, CNN_MaxPooling, timlCNNPoolingParamsDefault()); // max pooling layer
   timlCNNAddNormLayer(cnn, timlCNNNormParamsDefault());                                   // norm layer
   timlCNNAddDropoutLayer(cnn, 0.5);                                                       // dropout layer
   timlCNNAddLinearLayer(cnn, 10, timlCNNLinearParamsDefault());                           // linear layer
   timlCNNAddNonlinearLayer(cnn, Util_Softmax);                                            // softmax layer
   timlCNNInitialize(cnn);
   timlCNNReset(cnn);
~~~~~~~~~~~~~~~

\subsubsection subsubsectionInputLayer Input

The input layer is responsible for preprocessing the raw input data. The user can choose to crop, scale, mirror, or subtract the mean form the raw image. The required parameters are the dimensions (row, column, channel) of the feature maps in the input layer.  Refer to `timlCNNAddInputLayer()` for more details.

\subsubsection subsubsectionConvolutionalLayer Convolutional

The convolutional layer performs 2D convolution or correlation between feature maps and kernels.  The required parameters are the 2D kernel dimension (row, column), kernel strides along row and column and the output feature map channel.  For each feature map in the previous layer, there will be a corresponding 2D kernel applied to it and links to each feature map in the next layer.  Refer to `timlCNNAddConvLayer()` for more detail.

\subsubsection subsubsectionNonlinearLayer Nonlinear

The nonlinear layer implements 1 nonlinearity, supported types are:

- rectified linear unit\n
\f$ f(z) = \max(0, z) \f$
- sigmoid\n
\f$ f(z) = \frac{1}{1+e^{-z}} \f$
- softmax\n
\f$ f(z)_j = \frac{e^{-z_j}}{\sum_{i=0}^{K}e^{-z_i}} \f$
- tanh\n
\f$ f(z) = \frac{e^{z}-e^{-z}}{e^{z}+e^{-z}} \f$
.

To add a nonlinear layer to the cnn structure, call the function `timlCNNAddNonlinearLayer()`.  Note that for image classification applications, the last layer is most commonly chosen to be a softmax nonlinear layer that output an array of class probabilities that sum up to 1. 

\subsubsection subsubsectionPoolingLayer Pooling

The pooling layer performs a local maxing or averaging operation on the feature maps.  The required parameters are the pooling kernel dimension (row, col), kernel strides along column and row and the pooling method.  Refer to `timlCNNAddPoolingLayer()` for more details.

\subsubsection subsubsectionNormalizationLayer Normalization

The normalization layer performs local contrast normalization across channels:\n
\f$
y^i = \frac{x^i}{(1+\frac{\alpha}{N}\sum^{\min(N-1, i+N/2)}_{j=\max(0, i-N/2)}x^j)^\beta}
\f$
,where \f$x^i\f$ stands for the feature map in the i-th channel.  The channel span N defaults to 5.  \f$\alpha\f$ and \f$\beta\f$ default to 0.001 and 0.75, respectively.  Refer to `timlCNNAddNormLayer()` for more details.

\subsubsection subsubsectionDropoutLayer Dropout

The dropout layer is used during training to help prevent overfitting.  Each element in the feature map is set to 0 (deactivated) according to a preset probability in the training phase.  Note the dropout layer is simply a pass through in the testing phase.  Refer to `timlCNNAddDropoutLayer()` for more details.

\subsubsection subsubsectionLinearLayer Linear

The linear layer is also referred to as the inner product layer or fully connected layer.  A traditional neural network layer, the feature map in the previous layer is first vectorized and then multiplied by a weight matrix to obtain the feature map of next layer.  The required parameter is the dimension of the output feature map.  Refer to `timlCNNAddLinearLayer()` for more details.

\subsection subsectionMemory Memory

Once the setup of the cnn structure is complete, `timlCNNInitialize()` is called to allocate the memory.  There are 3 levels of memory allocation specified inside `timlCNNTrainingParams`.
- Level 1 can be used both for training and testing and requires the most memory.
- Level 2 requires less memory but can only be used for testing.
- Level 3 uses even less memory by operating on a memory pool and can also only be used for testing. 

Note that this function does not initialize the kernels or weights in the convolutional and linear layers.  To perform that initialization the function `timlCNNReset()` is used.

The exact memory allocated in bytes can be obtained by calling `timlCNNMemory()`. 

`timlCNNResize()` is used to resize the dimension of a CNN. Once the input layer dimension is changed, the dimension of the following layers will be re-calcualted and re-allocated. 

`timlCNNClone()` creates a independent copy of a CNN. The function `timlCNNShareParams()` differs from `timlCNNClone()` in that the CNN structure returned by this function allocates its own feature map memory but points to the parameter memory of its target.
Therefore, `timlCNNShareParams()` returns a structure that takes less memory compared with the structure returned by `timlCNNClone()`, which allocates its own parameter memory.
The user should be careful when manipulating the shared copy of a CNN as it may write to the parameters of its target.
`timlCNNShareParams()` is used primarily to accelerate the training and testing of a CNN. Multiple shared copies of a CNN can work in parallel by using OpenMP.

To free the space allocated by the CNN, call the function `timlCNNDelete()`.

\subsection subsectionUtilityFunctions Utility Functions

Utility functions aim to perform miscellaneous functions that related to IO.

The phase of a CNN can be set to training or testing by calling `timlCNNSetMode()`. A CNN allocated with level 2 or 3 is not allowed to be set to the training mode as no memory is allocated to run the back propagation algorithm.
In the testing mode, only forward propagation will be performed.

CNN structure information can be printed to the console by using `timlCNNPrint()`. `timlCNNGetLayerNum()` returns the number of layers of the CNN.
`timlCNNGetParamsNum()` returns the total number of parameters in the CNN.

`timlCNNWriteToFile()` writes the cnn structure into a combination of text and binary files.  The key parameter of this function is the `timlUtilParamsLevel`, which specifies the level of details of the writing.
- Level 1 only writes the network structure to a text file without specifying the parameters or feature maps of the cnn.
The text file is formatted in a syntax that is compatible with Matlab script.
- Level 2 writes both the network structure text file and the binary parameter file.
- Level 3 writes one more state binary files.  Level 3 is only used for debugging purpose.
Note that the path of the binary files to read is written into the text file. 

Similarly, `timlCNNReadFromFile()` can be used to read a CNN from text or binary files.

One example of the generated text file is shown below:
~~~~~~~~~~~~~~~~~~
paramsBinaryFileName = './database/test/cnn/timl_cnn_simple_config.m.params';
stateBinaryFileName  = './database/test/cnn/timl_cnn_simple_config.m.state';

cnn.params.count          = 0;
cnn.params.batchSize      = 100;
cnn.params.epoch          = 1;
cnn.params.learningRate   = 0.1000;
cnn.params.momentum       = 0.0000;
cnn.params.phase          = 0;
cnn.params.allocatorLevel = 0;
cnn.params.costType       = 0;

layerNum                                    = 8;
cnn.layer(1).id                             = 1;
cnn.layer(1).type                           = 0;
cnn.layer(1).row                            = 28;
cnn.layer(1).col                            = 28;
cnn.layer(1).channel                        = 1;
cnn.layer(1).inputParams.row                = 28;
cnn.layer(1).inputParams.col                = 28;
cnn.layer(1).inputParams.channel            = 1;
cnn.layer(1).inputParams.scale              = 1.0000;
cnn.layer(1).inputParams.trainingCropType   = 0;
cnn.layer(1).inputParams.trainingMirrorType = 1;
cnn.layer(1).inputParams.testingCropType    = 0;
cnn.layer(1).inputParams.testingMirrorType  = 1;

cnn.layer(2).id                                 = 2;
cnn.layer(2).type                               = 1;
cnn.layer(2).row                                = 24;
cnn.layer(2).col                                = 24;
cnn.layer(2).channel                            = 6;
cnn.layer(2).convParams.kernelRow               = 5;
cnn.layer(2).convParams.kernelCol               = 5;
cnn.layer(2).convParams.padUp                   = 0;
cnn.layer(2).convParams.padDown                 = 0;
cnn.layer(2).convParams.padLeft                 = 0;
cnn.layer(2).convParams.padRight                = 0;
cnn.layer(2).convParams.strideX                 = 1;
cnn.layer(2).convParams.strideY                 = 1;
cnn.layer(2).convParams.inputFeatureMapChannel  = 1;
cnn.layer(2).convParams.outputFeatureMapChannel = 6;
cnn.layer(2).convParams.type                    = 0;
cnn.layer(2).convParams.kernelDecayFactor       = 1.0000;
cnn.layer(2).convParams.kernelInit.type         = 3;
cnn.layer(2).convParams.kernelLearningFactor    = 1.0000;
cnn.layer(2).convParams.biasInit.type           = 0;
cnn.layer(2).convParams.biasLearningFactor      = 1.0000;

cnn.layer(3).id                   = 3;
cnn.layer(3).type                 = 3;
cnn.layer(3).row                  = 24;
cnn.layer(3).col                  = 24;
cnn.layer(3).channel              = 6;
cnn.layer(3).nonlinearParams.type = 0;

cnn.layer(4).id                     = 4;
cnn.layer(4).type                   = 2;
cnn.layer(4).row                    = 12;
cnn.layer(4).col                    = 12;
cnn.layer(4).channel                = 6;
cnn.layer(4).poolingParams.type     = 0;
cnn.layer(4).poolingParams.scaleRow = 2;
cnn.layer(4).poolingParams.scaleCol = 2;
cnn.layer(4).poolingParams.padUp    = 0;
cnn.layer(4).poolingParams.padDown  = 0;
cnn.layer(4).poolingParams.padLeft  = 0;
cnn.layer(4).poolingParams.padRight = 0;
cnn.layer(4).poolingParams.strideX  = 2;
cnn.layer(4).poolingParams.strideY  = 2;

cnn.layer(5).id                 = 5;
cnn.layer(5).type               = 6;
cnn.layer(5).row                = 12;
cnn.layer(5).col                = 12;
cnn.layer(5).channel            = 6;
cnn.layer(5).dropoutParams.prob = 0.5000

cnn.layer(6).id               = 6;
cnn.layer(6).type             = 5;
cnn.layer(6).row              = 12;
cnn.layer(6).col              = 12;
cnn.layer(6).channel          = 6;
cnn.layer(6).normParams.type  = 0;
cnn.layer(6).normParams.N     = 5;
cnn.layer(6).normParams.alpha = 0.0010;
cnn.layer(6).normParams.beta  = 0.7500;

cnn.layer(7).id                                = 7;
cnn.layer(7).type                              = 4;
cnn.layer(7).row                               = 1;
cnn.layer(7).col                               = 1;
cnn.layer(7).channel                           = 10;
cnn.layer(7).linearParams.dim                  = 10;
cnn.layer(7).linearParams.prevDim              = 864;
cnn.layer(7).linearParams.weightDecayFactor    = 1.0000;
cnn.layer(7).linearParams.weightInit.type      = 3;
cnn.layer(7).linearParams.weightLearningFactor = 1.0000;
cnn.layer(7).linearParams.biasInit.type        = 0;
cnn.layer(7).linearParams.biasLearningFactor   = 1.0000;

cnn.layer(8).id                   = 8;
cnn.layer(8).type                 = 3;
cnn.layer(8).row                  = 1;
cnn.layer(8).col                  = 1;
cnn.layer(8).channel              = 10;
cnn.layer(8).nonlinearParams.type = 1;
~~~~~~~~~~~~~~~~~~

Note that the text file is formatted using Matlab syntax such that the text file can be used as a script to obtain a cnn structure object.

\subsection cnnTraining Training

The following code block in `testCNNSimpleTraining()` performs training:

~~~~~~~~~~~~~~~{.c}
  // read MNIST database
   printf("2. Read the MNIST database\n");
   timlUtilReadMNIST(DATABASE_PATH, &training, &testing);

   // training
   printf("3. Start training\n");
   clock_gettime(CLOCK_REALTIME, &startTime);
   for (i = 0; i < batchNum; i++) {
      timlCNNSupervisedTrainingWithLabelBatchMode(cnn, training.data + i*batchSize*dim, training.label + i*batchSize, dim, batchSize);
   }
   clock_gettime(CLOCK_REALTIME, &endTime);
   trainingTime = timlUtilDiffTime(startTime, endTime);
   printf("Training time = %.2f s.\n", trainingTime/1000000.0);
~~~~~~~~~~~~~~~ 

In this example, the training and testing image data set structures are read from the MNIST database and then passed into `timlCNNSupervisedTrainingWithLabelBatchMode()`.
Note that there is also a multi-thread version of this function that called `timlCNNSupervisedTrainingWithLabelBatchMode()`.
The training time is returned by `timlUtilDiffTime()` in microsecond precision. 

\subsection subsectionTesting Testing

The following code block in `testCNNSimpleTesting()` performs testing:

~~~~~~~~~~~~~~~{.c}
	for(i = 0; i < testing.num; i++)
	{
		label = timlCNNClassifyTop1SingleMode(cnn, testing.data + i*dim, dim);
		if (label != testing.label[i]) misClassifyNum++;
	}
~~~~~~~~~~~~~~~ 

`timlCNNClassifyTop1SingleMode()` returns the top 1 label generated by the CNN.
A similar function `timlCNNClassifyTopNBatchMode()` that returns the top N labels together with their corresponding probabilities for a batch of data.
Note that there is also a multi-thread version of this function called `timlCNNClassifyTopNBatchModeOpenMP()` that classifies a batch of images using OpenMP.
 
\section sectionApplications Applications

Application source code is located at <KBD><install_directory>/src/app</KBD>. To run the applications, change the directory to the corresponding binary files and run the applications.<BR>
There are 1 application example for Caffe to TIML CNN model interoperation:
- `appCNNInteropCaffe`: Caffe interoperation

There are 2 application example for Caffe to TIML CNN database conversion:
- `appCNNConvertImageNet`: ImagNet conversion
- `appCNNConvertSBD`: SBD conversion

There are 8 application examples for CNN classification:
- `appCNNClassMNISTTraining()`: MNIST database training
- `appCNNClassMNISTTesting()`: MNIST database testing
- `appCNNClassCIFAR10Training()`: CIFAR10 database training
- `appCNNClassCIFAR10Testing()`: CIFAR10 database testing
- `appCNNClassCaffeNetTraining()`: CaffeNet database training
- `appCNNClassCaffeNetTesting()`: CaffeNet database testing
- `appCNNClassAlexNetTesting()`: AlexNet database training
- `appCNNClassVGGNetTesting()`: VGGNet database testing

There are 2 application examples for CNN scene labeling:
- `appCNNSceneSBDTraining()`: scene labeling database training
- `appCNNSceneSBDTesting()`: scene labeling database testing

\subsection subsectionClassification Classification

Training and testing a CNN for image classification is very straightforward to implement using the TIML library. Let's take the MNIST database for example. 
Here is one code block in `appCNNClassMNISTTraining()`. There are 3 major steps. First, build up the CNN structure using the library API. Next, read the database.
Third, apply the training function on the database. After the training, you can write the trained network to file(s) using `timlCNNWriteToFile()`.
~~~~~~~~~~~~~~~{.c}
   // setup CNN
   printf("1. Build up the CNN\n");
   timlConvNeuralNetwork *cnn = timlCNNCreateConvNeuralNetwork(timlCNNTrainingParamsDefault(), 0);
   cnn->params.learningRate = LEARN_RATE;
   cnn->params.batchSize    = BATCH_SIZE;
   inputParams = timlCNNInputParamsDefault();
   inputParams.scale = 1.0/256.0;
   timlCNNAddInputLayer(cnn, IMAGE_ROW, IMAGE_COL, IMAGE_CHANNEL, inputParams);             // input layer
   convParams = timlCNNConvParamsDefault();
   convParams.kernelInit.type = Util_Xavier;
   timlCNNAddConvLayer(cnn, 5, 5, 1, 1, 20, convParams);                                    // conv layer
   poolingParams = timlCNNPoolingParamsDefault();
   timlCNNAddPoolingLayer(cnn, 2, 2, 2, 2, CNN_MaxPooling, poolingParams);                  // max pooling layer
   convParams = timlCNNConvParamsDefault();
   convParams.kernelInit.type = Util_Xavier;
   timlCNNAddConvLayer(cnn, 5, 5, 1, 1, 50, convParams);                                    // conv layer
   timlCNNAddPoolingLayer(cnn, 2, 2, 2, 2, CNN_MaxPooling, timlCNNPoolingParamsDefault());  // max pooling layer
   timlCNNAddLinearLayer(cnn, 500, timlCNNLinearParamsDefault());                           // linear layer
   timlCNNAddNonlinearLayer(cnn, Util_Relu);                                                // relu layer
   timlCNNAddLinearLayer(cnn, 10, timlCNNLinearParamsDefault());                            // linear layer
   timlCNNAddNonlinearLayer(cnn, Util_Softmax);                                             // softmax layer
   timlCNNInitialize(cnn);
   timlCNNReset(cnn);
   mem = timlCNNMemory(cnn);
   timlCNNPrint(cnn);
   printf("CNN memory allocation = %.10f MB.\n", (float) mem/1024.0/1024.0);
   printf("CNN parameter #       = %ld.\n", timlCNNGetParamsNum(cnn));

   // read MNIST database
   printf("2. Read the MNIST database\n");
   timlUtilReadMNIST(DATABASE_PATH, &training, &testing);

   // training
   printf("3. Start training\n");
   clock_gettime(CLOCK_REALTIME, &startTime);
   for (i = 0; i < batchNum; i++) {
      timlCNNSupervisedTrainingWithLabelBatchMode(cnn, training.data + i*batchSize*dim, training.label + i*batchSize, dim, batchSize);
   }
   clock_gettime(CLOCK_REALTIME, &endTime);
   trainingTime = timlUtilDiffTime(startTime, endTime);
   printf("Training time = %.2f s.\n", trainingTime/1000000.0);
~~~~~~~~~~~~~~~
Deploying or testing the CNN is even simpler. Here is one code block in `appCNNClassMNISTTesting()`. Again, there are 3 major steps.
First, read the CNN structure from file(s). Next, read the testing database. Third, apply the testing function to produced the labels generated by the CNN.
~~~~~~~~~~~~~~~{.c}
   // read CNN config
   printf("1. Read CNN config\n");
   timlConvNeuralNetwork *cnn = timlCNNReadFromFile(MODEL_PATH, 0);
   timlCNNSetMode(cnn, Util_Tes\subsection subsectionSceneLabeling Scene Labelingt);
   mem = timlCNNMemory(cnn);
   timlCNNPrint(cnn);
   printf("CNN memory allocation = %.10f MB.\n", (float)mem/1024.0/1024.0);
   printf("CNN parameter #       = %lu.\n", timlCNNGetParamsNum(cnn));

   // read MNIST database
   printf("2. Read MNIST database\n");
   timlUtilReadMNIST(DATABASE_PATH, &training, &testing);

   // testing
   printf("3. Start testing\n");
   clock_gettime(CLOCK_REALTIME, &startTime);
   timlCNNClassifyTopNBatchMode(cnn, testing.data, dim, testing.num, label, NULL, topN);
   clock_gettime(CLOCK_REALTIME, &endTime);
   testingTime = timlUtilDiffTime(startTime, endTime);
   classifyNum = timlUtilClassifyAccuracy(label, topN, testing.num, testing.label);
   classifyPercent = (float)classifyNum/(float)testing.num;
   printf("Testing time      = %.3f s\n", testingTime/1000000.0);
   printf("Classify accuracy = %.3f %%\n", classifyPercent*100.00);
~~~~~~~~~~~~~~~

\subsection subsectionSceneLabeling Scene Labeling

Scene labeling consists in labeling each pixel in an image with the category of the object it belongs to. Instread of producing one lable for the entire image,
scene labeling produces one label for each pixel in the image. Therefore, training a CNN for scene labeling is slightly different from training a CNN for classification purpose.
The setup of the CNN follows the same procedure:

~~~~~~~~~~~~~~~{.c}
   // build up the CNN
   printf("1. Build up the CNN\n");
   cnn = timlCNNCreateConvNeuralNetwork(timlCNNTrainingParamsDefault(), 0);
   timlCNNAddInputLayer(cnn, PATCH_SIZE, PATCH_SIZE, IMAGE_CHANNEL, timlCNNInputParamsDefault());
   timlCNNAddConvLayer(cnn, 6, 6, 1, 1, 25, timlCNNConvParamsDefault());                    // conv layer
   timlCNNAddNonlinearLayer(cnn, Util_Tanh);                                                // tanh layer
   timlCNNAddPoolingLayer(cnn, 8, 8, 8, 8, CNN_MaxPooling, timlCNNPoolingParamsDefault());  // max pooling layer
   timlCNNAddConvLayer(cnn, 3, 3, 1, 1, 50, timlCNNConvParamsDefault());                    // conv layer
   timlCNNAddNonlinearLayer(cnn, Util_Tanh);                                                // tanh layer
   timlCNNAddPoolingLayer(cnn, 2, 2, 2, 2, CNN_MaxPooling, timlCNNPoolingParamsDefault());  // max pooling layer
   timlCNNAddLinearLayer(cnn, 8, timlCNNLinearParamsDefault());                             // linear layer
   timlCNNAddNonlinearLayer(cnn, Util_Softmax);                                             // softmax layer
~~~~~~~~~~~~~~~ 

The second step is to setup the training database:
~~~~~~~~~~~~~~~{.c}
   slTraining.num              = TRAIN_IMAGE_NUM;
   slTraining.row              = IMAGE_ROW;
   slTraining.col              = IMAGE_COL;
   slTraining.channel          = IMAGE_CHANNEL;
   slTraining.patchSize        = PATCH_SIZE;
   slTraining.imageFileNameStr = TRAIN_IMAGE_PATH;
   slTraining.labelFileNameStr = TRAIN_LABEL_PATH;
~~~~~~~~~~~~~~~ 

In this example, 450 images are used for training and 143 images are used for testing.
The dimension of the images are 240*320*3.  There are 450 text file labels in the training database, each with a 240*320 label matrix.
The label integer ranges from -1 to 7 (8 classes) with -1 indicating an unlabeled pixel.
The image and label text file name must follow the format as indicated in the imageFileNameStr and labelFileNameStr.
For each pixel in the image, a 133*133 patch centered at the pixel is passed into the CNN to output a label.

To train the database, the CNN first randomly selects an image and then randomly selects a pixel.
Next, a patch centered at that pixel is passed to the CNN for training.
The pixels are randomly selected without replacement, with 240*320*450 iterations needed to sweep through the entire database 1x.
There is a specialized training function:
~~~~~~~~~~~~~~~{.c}
appCNNSceneSupervisedTraining(cnn, &slTraining);
~~~~~~~~~~~~~~~ 

To test one image, a natural way is to generate a patch for each pixel which requires 240*320 forward passes through the CNN.
However, there is more efficient way to do this which exploits the convolutional structure.
First, pad zeros on the test image and shift the image in all four directions.
The number of shifted and zero padded images is proportional to the number of pooling layers in the CNN.
Next, pass the shifted and zero padded image to the trained CNN.
Finally, merge the output feature maps into a label matrix for the image.
Using this approach, the input feature map size is no longer the patch size which is 133*133 in the above example.
We need to re-calculate the input feature map dimensions and use function `timlCNNResize()` to resize the CNN.
Note that the above cnn has gone through 2 max pooling layers which scales down the feature map by a factor of 2*8 in the row and column dimensions.
The formula to calculate the resized row and col for the input layer is:
~~~~~~~~~~~~~~~{.c}
   printf("3. Resize the feature maps\n");
   resolutionLossRow = 8*2; // resolution loss due to max pooling
   resolutionLossCol = 8*2; // resolution loss due to max pooling
   resizeRow = slTraining.row + (slTraining.patchSize/2)*2 - (resolutionLossRow - 1);
   resizeCol = slTraining.col + (slTraining.patchSize/2)*2 - (resolutionLossCol - 1);
   timlCNNResize(cnn, resizeRow, resizeCol, slTraining.channel);
~~~~~~~~~~~~~~~ 

Multiple forward passes through the same CNN can be performed in parallel.
First, create multilple shared copies of the CNN to form a team called cnnTeam. Then we can call the function `appCNNSceneClassifyOpenMP()` to perform the labeling operation.
A single-thread version of the function also exists as `appCNNSceneClassify()`;
The parameter scale in `appCNNSceneClassifyOpenMP()` stands for the scale down factor of the generated label matrix.
When scale == 1, no downscaling is performed.
When scale == 4, the generated label matrix would be of size 60*80 and then upscaled to 240*320 to match the size of the image.
Downscaling can effectively reduce the labeling time.

~~~~~~~~~~~~~~~{.c}
   // create cnnTeam
   cnnTeam[0] = cnn;
   for (i = 1; i < thread; i++) {
      cnnTeam[i] = timlCNNShareParams(cnn, 0);
   }

   // testing
   printf("2. Start testing\n");
   for (i = 0; i < slTesting.num; i++) {
      printf("Read image %03d.jpg\n", i);
      sprintf(str, slTesting.imageFileNameStr, i);
      timlUtilReadFixedSizeJPEG(str, image, slTesting.row, slTesting.col, slTesting.channel);
      clock_gettime(CLOCK_REALTIME, &startTime);
      appCNNSceneClassifyOpenMP(cnnTeam, thread, image, slTesting.row, slTesting.col, slTesting.channel, labelMatrix, scale);
      clock_gettime(CLOCK_REALTIME, &endTime);
      testingTime = timlUtilDiffTime(startTime, endTime);

      // read true label
      sprintf(str, slTesting.labelFileNameStr, i);
      fp = fopen(str, "rt");
      for (n = 0; n < slTesting.row; n++) {
         for (m = 0; m < slTesting.col; m++) {
            fscanf(fp, "%d", trueLabelMatrix + n*slTesting.col + m);
         }
         fscanf(fp, "\n");
      }
      fclose(fp);

      // calculate accuracy
      labelAccuracy = appCNNSceneAccuracy(labelMatrix, trueLabelMatrix, slTesting.row*slTesting.col);
      printf("Test image %03d label accuracy = %.2f %%\n", i, 100.0*labelAccuracy);
      printf("Test image %03d time           = %.3f s\n", i, testingTime/1000000.0);
   }
~~~~~~~~~~~~~~~ 

\section sectionBenchmarks Benchmarks

The benchmark source code is located at <KBD><install_directory>/src/benchmark</KBD>.

There are 2 examples for CNN classification benchmark:
- `benchmarkCNNClassCaffeNetTesting()` : CaffeNet benchmark
- `benchmarkCNNClassVGGNetTesting()` : VGGNet benchmark

These two functions will benchmark the memory usage and processing time for each individual layers in the network.

*/
